data.num <- length(data)
out <- matrix(NA,data.num,50)

for (kaiji in 1:data.num){
citizens <- rate(data[[kaiji]][,3])
M <- data[[kaiji]][,2]

### malapportionment
out[kaiji,1] <- dif.LH(M,citizens)
out[kaiji,2] <- dif.MN(M,citizens)
out[kaiji,36] <- dif.G(M,citizens)
out[kaiji,37] <- dif.chi(M,citizens)

### gerrymandiering
vote.mat <- data[[kaiji]][,-c(1:3)]
vote.rate.mat <- vote.mat/apply(vote.mat,1,sum)
vote.rate.mean <- rate(apply(vote.mat,2,sum))
# MN and LH index
dif.MN.out <- dif.MN.out.five <- dif.LH.out <- dif.chi.out <- dif.G.out <-array()
dist.num <- nrow(vote.mat)
no.zero <- which(vote.rate.mean!=0)
for (dist in 1:dist.num){
# Mn is inappropraite because vote.rate is not integer
dif.MN.out[dist] <- dif.MN(vote.rate.mat[dist,],vote.rate.mean)
dif.LH.out[dist] <- dif.LH(vote.mat[dist,],vote.rate.mean)
dif.chi.out[dist] <- dif.chi(vote.rate.mat[dist,no.zero],vote.rate.mean[no.zero])
dif.G.out[dist] <- dif.G(vote.mat[dist,],vote.rate.mean)
}
out[kaiji,3] <- sum(dif.MN.out)/(dist.num-1) # mean(gerry)
out[kaiji,5] <- mean(dif.LH.out)
out[kaiji,11] <- sum(dif.MN.out)
out[kaiji,26] <- sum(dif.chi.out)/(dist.num-1)
out[kaiji,38] <- mean(dif.G.out)

### largest party
largest <- which(vote.rate.mean[-1]==max(vote.rate.mean[-1]))+1
out[kaiji,6] <- sd(vote.rate.mat[,largest])

### variance
out[kaiji,7] <- sum(apply(vote.rate.mat,2,var))
out[kaiji,8] <- mean(apply(vote.rate.mat,2,var))
out[kaiji,9] <- sum(apply(vote.rate.mat,2,var))/(ncol(vote.rate.mat)-1)
out[kaiji,24] <- sum(na.omit(apply(vote.rate.mat,2,sd)/apply(vote.rate.mat,2,mean)))
out[kaiji,25] <- mean(na.omit(apply(vote.rate.mat,2,sd)/apply(vote.rate.mat,2,mean)))

### interaction
dif.M <- rate(M)*log((rate(M)/rate(citizens)))
dif.M.std <- dif.M/sqrt(rate(citizens))
dif.largest <- t(t(vote.rate.mat)-vote.rate.mean)[,largest]

out[kaiji,12] <- apply(abs(t(t(vote.rate.mat)-vote.rate.mean)),1,sum)%*%(rate(M)-rate(citizens))
out[kaiji,13] <- dif.largest%*%(rate(M)-rate(citizens))
out[kaiji,15] <- dif.LH.out%*%dif.M
out[kaiji,16] <- dif.LH.out%*%dif.M.std
out[kaiji,21] <- cor(dif.largest,dif.M)

out[kaiji,27] <- cor(dif.chi.out,dif.M)
out[kaiji,28] <- cor(dif.MN.out,dif.M)
out[kaiji,29] <- cor(dif.LH.out,dif.M)

out[kaiji,30] <- cor(dif.chi.out,dif.M, method = "spearm")
out[kaiji,31] <- cor(dif.MN.out,dif.M, method = "spearm")
out[kaiji,32] <- cor(dif.LH.out,dif.M, method = "spearm")

out[kaiji,33] <- sign.cor(dif.chi.out,dif.M)
out[kaiji,34] <- sign.cor(dif.MN.out,dif.M)
out[kaiji,35] <- sign.cor(dif.LH.out,dif.M)
}


