library(foreign)

# Lower House
data.LH <- list()
winner.LH <- list()
party.LH <- list()
# Kawato: 1890-1990
data.LH.prewar.original <- read.csv("kawato_prewar_HR.csv")
data.LH.postwar.original <- read.csv("kawato_postwar_HR.csv")
data <- rbind(data.LH.prewar.original[,c(1:9,15)],data.LH.postwar.original[,c(1:9,15)])

# Amami see Kawato 1990, p. 679
amami <- (data[,1]==1953 &data[,2]==4 & data[,3]==46 & data[,4]==4)#Kagoshima 4
data <- data[!amami,]
# uncotested districts deleted
data[data[,5]==998,9] <- NA #
data[data[,5]==999,9] <- NA #
data <- na.omit(data)

ecode <- data[,1]-1900+(data[,2]/12)
unique.ecode <- sort(unique(ecode))
data[data[,5]==997,9] <- 2 # sanpyo

tosen <- data[,6]-data[,5]#teisu-rank
winner <- as.integer(tosen>=0)
winner[data[,1]>=1947 & data[,5]==0] <- 0

for (kaiji in 1:39){
  e.pickup <- which(ecode==unique.ecode[kaiji])
  data.e <- data[e.pickup,]
  winner.e <- winner[e.pickup]
  dcode <- (data.e[,3]*100)+data.e[,4]
  unique.dcode <- sort(unique(dcode))
  dcode.num <- length(unique.dcode)
  party.LH[[kaiji]] <- party <- sort(unique(c(1,data.e[,9])))
  party.num <- length(party)
  data.out <- matrix(0,dcode.num,(3+party.num))
  winner.out <- matrix(0,dcode.num,party.num)
  colnames(data.out[,c(4:(3+party.num))]) <- colnames(winner.out) <- party.LH[[kaiji]]
  data.out[,1] <- kaiji
  for (dist in 1:dcode.num){
    d.pickup <- which(dcode==unique.dcode[dist])
    data.d <- data.e[d.pickup,]
    winner.d <- winner.e[d.pickup]
    cand.num <- nrow(data.d)
    data.out[dist,2] <- data.d[cand.num,6]# M
    data.out[dist,3] <- data.d[1,10]# citizens
    for (cand in 1:cand.num){
      which.party <- which(party == data.d[cand,9])
      data.out[dist,(3+which.party)] <- data.out[dist,(3+which.party)] + data.d[cand,8]# vote
      winner.out[dist,which.party] <- winner.out[dist,which.party] + winner.d[cand]
    }
 }
  data.LH[[kaiji]] <- data.out
  winner.LH[[kaiji]] <- winner.out#[,-c(3:4)]# invalid, abst
}

ballot.LH <- ballot.UH <- ballot.PR <- M.LH <- M.PR <- M.UH <- list()
for (kaiji in 1:39){
M.LH[[kaiji]] <- data.LH[[kaiji]][,2]
ballot.LH[[kaiji]] <- rep(1,length(M.LH[[kaiji]]))
}
for (kaiji in 1:6){
ballot.LH[[kaiji]] <- M.LH[[kaiji]]
}
kaiji <- 22
ballot.LH[[kaiji]] <- as.integer(M.LH[[kaiji]]>=11)+2

vote.to.seat.out.LH <- vote.to.seat.all(data.LH,winner.LH,party.LH,ballot.LH)


